#include <stdio.h>
#include "parti.h"

SCHED *schedule(local,proc,ndata,maxdim)
int *local,*proc,ndata,maxdim;
{
  int *bl,*pl,**perms,**buckets,*bsize;
  int *GColor;
  struct com_pattern *sr;
  SCHED *sched;
  int   i;
 
#ifdef DEBUG 
  trace_enter("schedule");
#endif
  sched		= (SCHED *) malloc(sizeof(SCHED));
  bl		= (int *) malloc(sizeof(int)*ndata);
  pl		= (int *) malloc(sizeof(int)*ndata);
  perms		= (int **) malloc(sizeof(int *)*PARTI_numnodes);
  buckets	= (int **) malloc(sizeof(int *)*PARTI_numnodes);
  bsize		= (int *) malloc(sizeof(int)*PARTI_numnodes);
  sched->global_refs = NULL;
  sched->local_refs = NULL;
  bsort(PARTI_numnodes,ndata,proc,local,bsize,buckets,perms,bl,pl);
  sr = schedule_gather(bsize,buckets,maxdim);

  GColor  = (int *) malloc(sizeof(int)*PARTI_numnodes);
  PairColor(GColor, PARTI_mynode);
  sr->gcolor    = GColor;

  sched->sr 	= sr;
  sched->perm 	= pl;
  sched->ndata 	= ndata;

  free(perms);
#ifdef DEBUG
  trace_exit();
#endif
  return(sched);
}

SCHED *schedulen(local,proc,global,lcl,ndata,maxdim)
int *local,*proc,ndata,*global,*lcl,maxdim;
{
  int *bl,*pl,**perms,**buckets,*bsize;
  int *GColor;
  struct com_pattern *sr;
  SCHED *sched;
  int   i;
 
#ifdef DEBUG 
  trace_enter("schedule");
#endif
  sched		= (SCHED *) malloc(sizeof(SCHED));
  if( ndata > 0 ) {
  bl		= (int *) malloc(sizeof(int)*ndata);
  pl		= (int *) malloc(sizeof(int)*ndata);
  sched->global_refs = (int *) malloc(sizeof(int)*ndata);
  sched->local_refs = (int *) malloc(sizeof(int)*ndata);
  }
  else {
    bl		= (int *) malloc(sizeof(int));
    pl		= (int *) malloc(sizeof(int));
    sched->global_refs = (int *) malloc(sizeof(int));
    sched->local_refs = (int *) malloc(sizeof(int));
  }

  perms		= (int **) malloc(sizeof(int *)*PARTI_numnodes);
  buckets	= (int **) malloc(sizeof(int *)*PARTI_numnodes);
  bsize		= (int *) malloc(sizeof(int)*PARTI_numnodes);
  bsort(PARTI_numnodes,ndata,proc,local,bsize,buckets,perms,bl,pl);
  sr = schedule_gather(bsize,buckets,maxdim);

  GColor  = (int *) malloc(sizeof(int)*PARTI_numnodes);
  PairColor(GColor, PARTI_mynode);
  sr->gcolor    = GColor;

  sched->sr 	= sr;
  sched->perm 	= pl;
  sched->ndata 	= ndata;
  for(i=0;i<ndata;i++){
      sched->global_refs[i] = global[i];
      sched->local_refs[i] = lcl[i];
  }

  free(perms);
#ifdef DEBUG
  trace_exit();
#endif
  return(sched);
}

void dref(local,proc,ndata,offset_table,proc_table)
int *local,*proc,ndata,*offset_table,*proc_table;
{
  SCHED *sr;
  int i,*local_deref,*proc_deref;
   
#ifdef DEBUG
  trace_enter("dref");
#endif
  local_deref = (int *) malloc(sizeof(int)*ndata);
  proc_deref = (int *) malloc(sizeof(int)*ndata);
   
  sr = schedule(local,proc,ndata,1);
  PARTI_gather(sr,local_deref,offset_table,sizeof(int));
  PARTI_gather(sr,proc_deref,proc_table,sizeof(int));

  for(i=0;i<ndata;i++){
    proc[i] = proc_deref[i];
    local[i] = local_deref[i];
  }
  free(local_deref);
  free(proc_deref);
}

SCHED *ischedule(local,proc,ndata,offset_table,proc_table)
int *local,*proc,ndata,*offset_table,*proc_table;
{
  SCHED *sr,*sr1;
  int *local_deref,*proc_deref;
 
#ifdef DEBUG 
  trace_enter("ischedule");
#endif
  local_deref = (int *) malloc(sizeof(int)*ndata);
  proc_deref = (int *) malloc(sizeof(int)*ndata);
 
  sr1 = schedule(local,proc,ndata,1);
  PARTI_gather(sr1,local_deref,offset_table,sizeof(int));
  PARTI_gather(sr1,proc_deref,proc_table,sizeof(int));
  sr = schedule(local_deref,proc_deref,ndata,1);
  return(sr);
#ifdef DEBUG 
  trace_exit();
#endif
}

TTABLE *build_translation_table(type,index_array,ndata)
int type,ndata,*index_array;
{
  int max_index,table_size,i,*offset,*local,*proc;
  SCHED *sr;
  TTABLE *table;
   
  offset = (int *) malloc(sizeof(int)*ndata);
  local = (int *) malloc(sizeof(int)*ndata);
  proc = (int *) malloc(sizeof(int)*ndata);
  table = (TTABLE *) malloc(sizeof(TTABLE));
   
  /* calculate the size of the table */
  max_index = 0;
  for(i=0;i<ndata;i++){
    max_index = (index_array[i]>max_index) ? index_array[i] : max_index;
  }  
  PARTI_gihigh(&max_index,1,&i);
  table_size = max_index/PARTI_numnodes+1;
  table->offset = (int *) malloc(sizeof(int)*table_size);
  table->proc = (int *) malloc(sizeof(int)*table_size);
   
  table->table_size = table_size;
  table->type = type;
  for(i=0;i<ndata;i++){
    offset[i] = i;
    if(type==BLOCKED){
      proc[i] = index_array[i] / table_size;
      local[i] = index_array[i] % table_size;
    }else{
      proc[i] = index_array[i] % PARTI_numnodes;
      local[i] = index_array[i] / PARTI_numnodes;
    }
  }              

  sr = schedule(local,proc,ndata,1);
  PARTI_scatter(sr,offset,table->offset,sizeof(int),NULL);

   
  for(i=0;i<ndata;i++){
    offset[i] = PARTI_mynode;
  }  
  PARTI_scatter(sr,offset,table->proc,sizeof(int),NULL);
  free(offset);
  free(local);
  free(proc);

  return(table);
}

 
void dereference(table,index_array,local,proc,ndata)
int *index_array,ndata;
int *local,*proc;
TTABLE *table;
{
  SCHED *sr;
  int i;
   
#ifdef DEBUG
  trace_enter("dreference");
#endif
  for(i=0;i<ndata;i++){
    proc[i] = (table->type == BLOCKED)
                ?       (index_array[i] / table->table_size)
                :       (index_array[i] % PARTI_numnodes);
    local[i] = (table->type == BLOCKED)
                ?       (index_array[i] % table->table_size)
                :       (index_array[i] / PARTI_numnodes);
  }              
 
  sr = schedule(local,proc,ndata,1);
  PARTI_gather(sr,local,table->offset,sizeof(int));
  PARTI_gather(sr,proc,table->proc,sizeof(int));
  free_sched(sr);
  return;

} 

TTABLE *
init_ttable_with_proc(type,color,ndata)
int type,ndata,*color;
{
  int max_index,table_size,i,*offset,*local,*proc;
  SCHED *sr;
  TTABLE *table;

  proc = (int *) malloc(sizeof(int)*ndata);
  table = (TTABLE *) malloc(sizeof(TTABLE));
  for(i=0; i<ndata; i++) {
    proc[i] = color[i];
  }
  table->offset = NULL;
  table->proc = proc;
  table->table_size = ndata;

  return table;
}

/*--------------------------------------------------------*/
